#
# EDOS testing framework
# Copyright (C) 2006 EDGE-IT
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 2 as published
# by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
# 02111-1307, USA.
#

#
# Author: Francois Dechelle <fdechelle@mandriva.com>
#

import ConfigParser
import os
from edostestrunner.testreporter import TestReporter,MultiReporter
from edostestrunner.xwikireporter import XwikiTestReporter
from edostestrunner.stdoutreporter import StdoutTestReporter

class Config:
    def __init__(self, configFile = None):
        if not configFile is None:
            files = [configFile]
        else:
            files = [ '/etc/edos-testrunner/testrunner.cfg', os.path.expanduser('~/.edos-testrunner.cfg')]
        self.configParser = ConfigParser.SafeConfigParser()
        self.configParser.read( files)

    def __instanciateReporter__( self, reporterName):
        d = dict()
        reporterClassName = None
        items = self.configParser.items( reporterName)
        try:
            for p in items:
                k,v = p
                if k != 'class':
                    d[k] = v
                else:
                    reporterClassName = v
        except:
            pass
        return eval( '%s(**d)' % reporterClassName)
    
    def getReporter(self):
        try:
            reporterList = self.configParser.get('Reporting', 'reporter').split(',')
        except:
            reporterList = []

        if len(reporterList) == 1:
            return self.__instanciateReporter__( reporterList[0])
        else:
            reporters = []
            for r in reporterList:
                reporters.append( self.__instanciateReporter__(r) )
            return MultiReporter(reporters)

