#
# EDOS testing framework
# Copyright (C) 2006 EDGE-IT
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 2 as published
# by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
# 02111-1307, USA.
#

#
# Author: Francois Dechelle <fdechelle@mandriva.com>
#
    
#
# XML test reporter
#

import xml.dom.ext

def makeXMLDateTime(d):
    return '%04d-%02d-%02dT%02d:%02d:%02d' % (d.year, d.month, d.day, d.hour, d.minute, d.second)

"""  Creates an XML document based on the Test Report XML Schema and writes this document in the test reports directory.
The document name is build using test name, suite, family and launch date.
"""
class XMLTestReporter:

    def reportCompleted(self,testReport):
        self.reportDocument = xml.dom.DOMImplementation.getDOMImplementation().createDocument( 'http://www.w3.org/2001/XMLSchema-instance','test-report',None)
        descriptionNode = self.reportDocument.createElement( 'description')
        descriptionNode.setAttribute( 'name', name)
        descriptionNode.setAttribute( 'suite', testReport.test.suite)
        descriptionNode.setAttribute( 'family', testReport.test.family)
        self.reportDocument.documentElement.appendChild( descriptionNode)

        statusNode = self.reportDocument.createElement( 'status')
        statusNode.setAttribute( 'value', testReport.status)
        self.reportDocument.documentElement.appendChild( statusNode)

        resultNode = self.reportDocument.createElement( 'result')
        resultNode.setAttribute( 'value', testReport.result)
        self.reportDocument.documentElement.appendChild( resultNode)

        launchDateNode = self.reportDocument.createElement( 'launch_date')
        xmlLaunchDate = makeXMLDateTime(testReport.launchDate)
        launchDateNode.appendChild( self.reportDocument.createTextNode( xmlLaunchDate))
        self.reportDocument.documentElement.appendChild( launchDateNode)

        completionDateNode = self.reportDocument.createElement( 'completion_date')
        xmlCompletionDate = makeXMLDateTime(testReport.completionDate)
        completionDateNode.appendChild( self.reportDocument.createTextNode( xmlCompletionDate))
        self.reportDocument.documentElement.appendChild( completionDateNode)

        filename = testReport.test.name + '_' + testReport.test.suite + '_' + testReport.test.family + '_' + xmlLaunchDate
        dir = edos.config.getConfigValue( 'testreport.directory')
        xml.dom.ext.PrettyPrint( self.reportDocument, open( dir + '/' + filename, 'w'))


